/*
 * Official Solution (Java 11)
 * Gyojun Youn
 * youngyojun [at] gmail [dot] com
 */

import java.util.Scanner;
import java.util.List;
import java.util.ArrayList;
import java.util.PriorityQueue;

public class Main {
	private static void die() {
		System.out.println("NO");
		System.exit(0);
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);

		int N = sc.nextInt();

		int X[] = new int[N+1];
		int Y[] = new int[N+1];
		int A[] = new int[N+1];
		int B[] = new int[N+1];

		for(int i = 1; i <= N; i++) {
			X[i] = sc.nextInt();
			Y[i] = sc.nextInt();
			A[i] = sc.nextInt();
			B[i] = sc.nextInt();
		}

		int O[] = new int[N+1];
		for(int i = 1; i <= N; i++) {
			O[X[i]] = i;
		}

		Seg seg = new Seg();
		for(int oi = 1; oi <= N; oi++) {
			int i = O[oi];
			A[i] = Math.max(A[i], seg.get(Y[i]) + 1);
			seg.upd(Y[i], A[i]);
		}

		seg.init();
		for(int oi = N; 0 < oi; oi--) {
			int i = O[oi];
			B[i] = Math.min(B[i], N - seg.get(N+1 - Y[i]));
			seg.upd(N+1 - Y[i], N+1 - B[i]);
		}


		List<Integer>[] G = new List[N+1];		
		for(int i = 0; i <= N; i++) {
			G[i] = new ArrayList();
		}

		for(int i = N; 0 < i; i--) {
			if(A[i] > B[i]) die();
			G[A[i]].add(i);
		}

		PriorityQueue<Long> H = new PriorityQueue();
		int Ans[] = new int[N+1];
		for(int t = 1; t <= N; t++) {
			for(int i : G[t]) {
				H.add((((long) B[i]) << 20) | i);
			}
			if(H.isEmpty()) die();

			long key = H.remove();
			int v = (int) (key & ((1 << 20) - 1));

			if(B[v] < t) die();
			Ans[v] = t;
		}

		System.out.println("YES");
		for(int i = 1; i <= N; i++) {
			System.out.printf("%d ", Ans[i]);
		}
		System.out.println();
	}
}

class Seg {
	static final int MX = 250055;

	int d[] = new int[MX];

	void init() {
		for(int i = 0; i < MX; i++) {
			d[i] = 0;
		}
	}
	
	void upd(int x, int r) {
		while(x < MX) {
			if(d[x] < r) d[x] = r;
			x += x & (-x);
		}
	}

	int get(int x) {
		int r = 0;
		while(0 < x) {
			if(r < d[x]) r = d[x];
			x -= x & (-x);
		}
		return r;
	}
}
